/*
 * SPDX-FileCopyrightText: 2010-2022 Espressif Systems (Shanghai) CO LTD
 *
 * SPDX-License-Identifier: CC0-1.0
 */

#include <stdio.h>
#include <inttypes.h>
#include "sdkconfig.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"

#include "esp_chip_info.h"
#include "esp_flash.h"
#include "esp_system.h"
#include "esp_chip_info.h"
#include "esp_flash.h"
#include "esp_system.h"
#include "esp_spiffs.h"
#include "esp_log.h"
#include "esp_timer.h"

#include "spiffs.h"
#include "spi.h"
#include "lcd.h"


#include "lv_conf.h"
#include "lvgl/lvgl.h"
#include "lv_port_disp.h"

static const char *TAG = "SYS";


esp_timer_handle_t timer_handle;

static void lv_tick_timer_callback(void* arg) {
    lv_tick_inc(1);
}

void init_lvgl_tick_timer(void) {
    // 创建定时器参数
    const esp_timer_create_args_t timer_args = {
        .callback = &lv_tick_timer_callback,
        .arg = NULL,
        .dispatch_method = ESP_TIMER_TASK,
        .name = "lv_tick_timer"
    };

    
    
    // 创建定时器
    ESP_ERROR_CHECK(esp_timer_create(&timer_args, &timer_handle));
    
    // 启动周期性定时器（1ms = 1000us）
    ESP_ERROR_CHECK(esp_timer_start_periodic(timer_handle, 1000));
    
}


void app_main(void)
{
    ESP_LOGI(TAG, "Hello world!");

    /* Print chip information */
    esp_chip_info_t chip_info;
    uint32_t flash_size;
    esp_chip_info(&chip_info);
    ESP_LOGI(TAG, "This is %s chip with %d CPU core(s), %s%s%s%s, ",
             CONFIG_IDF_TARGET,
             chip_info.cores,
             (chip_info.features & CHIP_FEATURE_WIFI_BGN) ? "WiFi/" : "",
             (chip_info.features & CHIP_FEATURE_BT) ? "BT" : "",
             (chip_info.features & CHIP_FEATURE_BLE) ? "BLE" : "",
             (chip_info.features & CHIP_FEATURE_IEEE802154) ? ", 802.15.4 (Zigbee/Thread)" : "");

    unsigned major_rev = chip_info.revision / 100;
    unsigned minor_rev = chip_info.revision % 100;
    ESP_LOGI(TAG, "silicon revision v%d.%d, ", major_rev, minor_rev);
    if (esp_flash_get_size(NULL, &flash_size) != ESP_OK)
    {
        ESP_LOGI(TAG, "Get flash size failed");
        return;
    }

    ESP_LOGI(TAG, "%" PRIu32 "MB %s flash", flash_size / (uint32_t)(1024 * 1024),
             (chip_info.features & CHIP_FEATURE_EMB_FLASH) ? "embedded" : "external");

    ESP_LOGI(TAG, "Minimum free heap size: %" PRIu32 " bytes", esp_get_minimum_free_heap_size());

    ESP_LOGI(TAG, "sizeof(int) ==%d", sizeof(int));


    // 1. 初始化 SPIFFS
    const char *spiffs_base_path = "/spiffs";
    esp_err_t ret = spiffs_init(spiffs_base_path);

    if (ret != ESP_OK)
    {
        ESP_LOGE(TAG, "SPIFFS 初始化失败");
    }
    else
    {
        ESP_LOGI(TAG, "SPIFFS 初始化OK");

        list_spiffs_files_safe(spiffs_base_path);
    }

    spi_init();
    lcd_init();
    //lv_timer_set_cb(custom_tick_get);

    lv_init();
    lv_port_disp_init();

    //init_lvgl_tick_timer();
  


   while(1)
   {

        lv_task_handler();
        vTaskDelay(1); // 必须让出CPU
   }
}
